
/***** Various include *****/

#include "ProgED:sources/include/Ped.h"



/*****
 *
 * FUNZIONE:	ULONG SAVEDS ASM main(char *line,char *sectionname)
 *
 * SCOPO:	Find a reference to an AmigaGuide node in the line
 *		pointed by "line". The reference name is copied into
 *		"sectionname".
 *
 * NOTE:	Use always the function geta4() or the directive __saveds!
 *
 * RESULT:	Lenght of the string copied into "sectionname".
 *		0=reference not found.
 *
 ****/

ULONG SAVEDS ASM main(RG(a0) char *line,RG(a1) char *sectionname)
{
	char	*p,
		*q,
		*d;
	int	i;



	/***** Check if the line starts with '@node' *****/
	p=line;
	if (*p)
	{
		if (p[0]=='@')
		if ((p[1]=='n')||(p[1]=='N'))
		if ((p[2]=='o')||(p[2]=='O'))
		if ((p[3]=='d')||(p[3]=='D'))
		if ((p[4]=='e')||(p[4]=='E'))
		{
			/***** Jumps over any spaces after "@node" *****/
			p+=5;
			while((*p==32)||(*p==9))	p++;

			/***** Copy the string till next space or TAB *****/
			if (*p)
			{
				q=p;
				if (*p==34)
				{
					q++;
					while((*q!=34)&&(*q)) q++;
				}
				else
				{
					while((*q!=32)&&(*q!=9)&&(*q))	q++;
				}
				if (*p==34)	p++;
				if (*(q-1)==34)	q--;

				/***** Copy the name and return! *****/
				d=sectionname;
				for(i=0;i<q-p;i++)	*d++=p[i];
				*d='\0';
				return(q-p);
			}
		}
	}

	/***** No reference found *****/
	return(0);
}
