
/***** Various include *****/

#include "ProgED:sources/include/Ped.h"
#include <string.h>



/*****
 *
 * FUNCTION:	ULONG SAVEDS ASM main(char *line,char *sectionname)
 *
 * AIM:		Find the reference to a C function in the line pointed
 *		by "line". The name of the function will be copied into
 *		"sectionname". Sometimes (depending how you write your
 *		programs) this scanner can fail his aim.
 *		I wrote this scanner following MY programming way.
 *		If your way isn't equal write a new scanner or
 *		improve this.
 *
 * NOTE:	Use always the function geta4() or the directive __saveds!
 *
 * RESULT:	Lenght of the string copied into "sectionname".
 *		0=reference not found.
 *
 ****/

ULONG SAVEDS ASM main(RG(a0) char *line,RG(a1) char *sectionname)
{
	char	*p,
		*q,
		*d,
		*r;
	int	 i,
		 n1,
		 n2;




	/***** If the line starts with 'static ' jumps over *****/
	if ((line[0]=='s')||(line[0]=='S'))
	if ((line[1]=='t')||(line[1]=='T'))
	if ((line[2]=='a')||(line[2]=='A'))
	if ((line[3]=='t')||(line[3]=='T'))
	if ((line[4]=='i')||(line[4]=='I'))
	if ((line[5]=='c')||(line[5]=='C'))
	if ((line[6]==32)||(line[6]==9))
	line+=7;

	/***** If the line starts with 'struct ' jumps over *****/
	if (line[0]=='s')
	if (line[1]=='t')
	if (line[2]=='r')
	if (line[3]=='u')
	if (line[4]=='c')
	if (line[5]=='t')
	if (line[6]==32)
	line+=7;

	/***** Check if, on the line, there are a SINGLE '(' and a SINGLE ')' *****/
	p=line;
	n1=n2=0;
	while(*p)
	{
		if (*p=='(')	n1++;
		if (*p==')')
		{
			r=p+1;
			n2++;
		}
		p++;
	}

	/****** If there is a SINGLE '(' and a SINGLE ')' perharps the function
		is splitted over more lines! In this case check the line, it
		should end with ','! *****/
	if ((n1==1)&&(!n2))
	{
		if (line[strlen(line)-1]==',')
		{
			r=line+strlen(line);
			n2=1;
		}
	}

	/****** Continue ONLY if there was a SINGLE '(' and a SINGLE ')' *****/
	if ((n1!=1)||(n2!=1))	return(0);

	/***** Now check if the ')' isn't followed by other chars (only ';' is allowed) *****/
	p=r;
	while(*p)
	{
		if ((*p!=32)&&(*p!=9)&&(*p!=';'))	break;
		p++;
	}

	if (*p)	return(0);

	/****** OK! Check if the line format is xxxx xxxx(.... *****/
	q=p=line;
	n1=0;
	while(*p)
	{
		if ((*p==32)||(*p==9))
		{
			q=p+1;
			n1++;
		}

		if (*p=='(')	break;

		p++;
	}

	if (n1>1)	return(0);

	if (n1==1)	if (q==line+1)	return(0);

	/***** if the return type is a pointer delete the '*' *****/
	if (*q=='*')	q++;

	/***** Copy the name and return *****/
	d=sectionname;
	for(i=0;i<p-q;i++)	*d++=q[i];
	*d='\0';
	return(p-q);
}

