
/***** Various include *****/

#include "ProgED:sources/include/Ped.h"



/*****
 *
 * FUNZIONE:	ULONG SAVEDS ASM main(char *line,char *sectionname)
 *
 * SCOPO:	Find a reference to a C structure in the line pointed
 *		by "line". The reference name will be copied into
 *		"sectionname".
 *
 * NOTE:	Use always the function geta4() or the directive __saveds!
 *
 * RESULT:	Lenght of the string copied into "sectionname".
 *		0=reference not found.
 *
 ****/

ULONG SAVEDS ASM main(RG(a0) char *line,RG(a1) char *sectionname)
{
	char	*p,
		*q,
		*q1,
		*d;
	int	i;



	p=line;

	/***** Check if the line starts with 'struct' *****/
	if (*p)
	{
		if (p[0]=='s')
		if (p[1]=='t')
		if (p[2]=='r')
		if (p[3]=='u')
		if (p[4]=='c')
		if (p[5]=='t')
		{
			/***** If YES, jump over spaces and TABs *****/
			p+=6;
			while((*p==32)||(*p==9))	p++;

			/***** Copy next word till next space or TAB.
				Return length in D0. *****/
			if (*p)
			{
				q=p;
				while((*q!=32)&&(*q!=9)&&(*q))	q++;

				q1=q;

				if (*q)	while((*q==32)||(*q==9))	q++;

				if ((!(*q))||(*q=='{'))
				{
					d=sectionname;
					for(i=0;i<q1-p;i++)	*d++=p[i];
					*d='\0';
					return(q1-p);
				}
			}
		}
	}

	/***** No reference found! *****/
	return(0);
}

